SystemOrganization addCategory: #'Forum-Model'!
SystemOrganization addCategory: #'Forum-Tests'!
SystemOrganization addCategory: #'Forum-Application'!
SystemOrganization addCategory: #'Forum-Base'!
SystemOrganization addCategory: #'Forum-Announcements'!

TestCase subclass: #FOQuestionTest
	instanceVariableNames: 'model author'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FOQuestionTest methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:45'!
setUp
	model := FOModel new.
	author := model authorNamed:'Stephan Eggermont'.! !

!FOQuestionTest methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:46'!
testAuthorAsksQuestion
	|question|
	question := model questionBy: author.
	self assert: (question author = author)! !

!FOQuestionTest methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:50'!
testQuestionsByAuthor
	|question question2|
	question := model questionBy: author.
	question2 := model questionBy: author.
	self assert: (((model questionsOf: author) size) = 2)! !

TestCase subclass: #FORegisterTest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Tests'!

!FORegisterTest methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 19:12'!
setUp
	model := FOModel new.! !

!FORegisterTest methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:43'!
testRegisterMeOnce
	|author|
	author := model authorNamed: 'Stephan Eggermont'.
	self assert: ((model authorNamed: 'Stephan Eggermont') == author)! !

WAFileLibrary subclass: #FOFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOFileLibrary methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 23:33'!
mainCss
	^'
	.topbar{
		width: 960px;
		background-color: #eeeeee;
		height: 30px;
		border: 0;
		margin: 0;
		padding: 0;
	}	
	.hlinks{
		float: right
	}
	.userspan{
		text-align: right;
		font-weight: bold;
		font-size: 12px;
		color: #0077CC;
		padding: 15px 20px 2px 0px;
	}
	
	.metaspan{
		text-align: right;
		font-weight: bold;
		font-size: 12px;
		color: #0077CC;
		padding: 4px 20px 2px 0px;
	}
	body{
		font-family:Arial,Liberation Sans,DejaVu Sans,sans-serif;
		border: 0;
		margin: 0;
		padding: 0;
	
	}
	.page-header .home{
		padding: 40px 10px 10px 10px;;
	}
	.home a{
		font-size: 32px;
		color: #111;
		text-decoration: none;
	}
	.homepage input{
		background-color: #aaa;
		color: white;
		border: 0;
	}
	.homepage input:hover{
		background-color: orange;
	}
.question{
	float: left;
	border-bottom: 1px dotted #999;
	overflow: hidden;
	width: 730px;
	display: block;
}
.votes{
	display: block;
	float: left;
	width: 38px;
	padding: 5px;
	text-align: center;
}	
.votes a{
	text-decoration: none;
	color: #aaa;
}
.summary{
	float: left;
	width: 550px;
	margin: 5px;
}
.question .count{
	font-size: 190%;
}
.summary .title{
	font-size: 14px;
	height: 20px;
}
.summary a{
	text-decoration: none;
}
.summary .contents{
	height: 30px;
	overflow: hidden;
	font-size: 12px;
}
.summary .author{
	float: right;
	font-size: 12px;
	color: blue;
}
.view-question h1{
	padding: 5px;
	font-size: 24px;
	border-bottom: 1px solid #aaa;
}
	'! !

WAComponent subclass: #FOAskQuestion
	instanceVariableNames: 'title contents tags author question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents
	^ contents! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
contents: anObject
	contents := anObject! !

!FOAskQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:03'!
postYourQuestion
	author := FOModel default authors first.
	question := FOModel default questionBy: author.
	question title: title;
		contents: contents;
		tags: tags.
		! !

!FOAskQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:01'!
renderContentOn: canvas
	canvas form:[
		canvas label: 'Title'.
		canvas textInput on: #title of: self.
		canvas break.
		canvas textArea on: #contents of: self.
		canvas break.
		canvas label: 'Tags'.
		canvas textInput on: #tags of: self.
		canvas break.
		canvas submitButton on: #postYourQuestion of: self]! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags
	^ tags! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
tags: anObject
	tags := anObject! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title
	^ title! !

!FOAskQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:00'!
title: anObject
	title := anObject! !

WAComponent subclass: #FOComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Base'!

FOComponent subclass: #FOAskQuestion2
	instanceVariableNames: 'editForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAskQuestion2 methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:22'!
cancel
	editForm := nil.
	self announce: FOGoHome! !

!FOAskQuestion2 methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:19'!
createEditForm
	^DEEditForm new 
		subject: FOQuestion new
		isNew: true;
		saveAction: [self save];
		cancelAction: [self cancel];
		title: '?';
		saveTextNew: 'Post your question';
		yourself! !

!FOAskQuestion2 methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:11'!
editForm
	^editForm ifNil: [editForm := self createEditForm]! !

!FOAskQuestion2 methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:10'!
renderContentOn: canvas
	canvas render: self editForm.! !

!FOAskQuestion2 methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:22'!
save
	|question|
	question := self editForm subject.
	question author: FOModel default authors first.
	FOModel default questions add: question.
	editForm := nil.
	self announce: FOGoHome! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
announce: aClass
	self session announce: aClass! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
announcer
	^self session announcer! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
announcer: anAnnouncer
	self session announcer: anAnnouncer! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
ifLoggedIn: aBlock
	self isLoggedIn ifTrue: [ aBlock value ]
! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
isLoggedIn
	^self session isLoggedIn! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
newAnnouncerUntil: anAnnouncement
	| oldAnnouncer |
	oldAnnouncer := self announcer.
	self resetAnnouncer.
	self announcer
		subscribe: anAnnouncement
		do: [ :ann | 
			self announcer: oldAnnouncer.
			self announce: ann ]
		for: self
	! !

!FOComponent methodsFor: 'rendering' stamp: 'StephanEggermont 4/29/2011 00:19'!
renderContentOn: canvas
	canvas heading: (self class className)! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
resetAnnouncer
	self session resetAnnouncer! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
user
	^self session user! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
user: aUser
	self session user: aUser! !

!FOComponent methodsFor: 'session' stamp: 'StephanEggermont 4/29/2011 00:19'!
username
	^self session username! !

FOComponent subclass: #FOHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 14:35'!
askQuestion
	self announce: FOGoAskQuestion! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:09'!
askQuestion2
	self announce: FOGoAskQuestion2! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 16:54'!
renderContentOn: canvas
	canvas div 
		class: 'homepage';
		with: [
	self renderQuestionHeaderOn: canvas.
	self renderQuestionsOn: canvas.]! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 15:05'!
renderQuestion: aQuestion on: canvas
	(canvas div)
		class: 'question';
		with: [ 
			self renderVotesOf: aQuestion on: canvas.
			self renderSummaryOf: aQuestion on: canvas] ! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:09'!
renderQuestionHeaderOn: canvas
	canvas submitButton on: #askQuestion of: self.
	canvas submitButton on: #askQuestion2 of: self.
	canvas break.
	canvas text: 'Top Questions'! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 23:31'!
renderQuestionsOn: canvas
	(FOModel default questions sortBy: [:a :b | a votesTotal > b votesTotal ])do: [:each|
		self renderQuestion: each on: canvas]! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 16:37'!
renderSummaryOf: aQuestion on: canvas
	canvas div
		class: 'summary';
		with: [ 
			canvas div 
				class: 'title';
				with: [
			(canvas anchor)
					callback: [ self viewQuestion: aQuestion ];
					with: aQuestion title].
			canvas div
				class: 'contents';
				with: aQuestion contents.
			canvas div 
				class: 'author';
				with: aQuestion author.]
 ! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 17:32'!
renderVotesOf: aQuestion on: canvas
	|nr|
	nr := aQuestion votesTotal.
	canvas div
		class: 'votes';
		with: [ 
			canvas div
				class: 'count';
				with: nr.
			nr = 1 ifTrue: [
				canvas div: 'vote'] 
			ifFalse: [			
				canvas div: 'votes' ]]! !

!FOHome methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:48'!
viewQuestion: aQuestion
	^ self announce: (FOGoViewQuestion on: aQuestion)! !

FOComponent subclass: #FOPageChoice
	instanceVariableNames: 'pages currentPage homepage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Base'!

FOPageChoice subclass: #FOAgileOverflow
	instanceVariableNames: 'mainComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOAgileOverflow class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 17:21'!
initialize
	"Registers this applicaton as webpage
		FOApplication initialize.
	"
	super initialize.
	(self registerAsApplication: 'AgileOverflow')
		preferenceAt: #sessionClass
			put: FOSession;
		addLibrary: FOFileLibrary;
		yourself
! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 00:33'!
askQuestion
	self announce: FOGoAskQuestion! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 21:55'!
children
	^Array with: mainComponent ! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:10'!
initialize 
	super initialize.
	self addPage: FOHome new announcement: FOGoHome.
	self addPage: FOAskQuestion new announcement: FOGoAskQuestion.
	self addPage: FOAskQuestion2 new announcement: FOGoAskQuestion2.
	self addPage: FOViewQuestion new announcement: FOGoViewQuestion symbol: #question.
! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 11:29'!
renderBottomOn: canvas! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 21:48'!
renderContentOn: canvas
	canvas form
		with: [
			self renderTopOn: canvas.
			self renderHeaderOn: canvas.
			self renderMainOn: canvas.
			self renderBottomOn: canvas]! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 16:47'!
renderHeaderOn: canvas
	canvas div 
		class: 'page-header';
		with: [
			canvas div 
				class: 'home';
				with: [
					canvas anchor 
						callback: [self goHome];
						with: 'AgileOverflow']]
! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:48'!
renderMainOn: canvas
	canvas div 
		class: 'mainleft';
		with: [canvas render: self currentPage]! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 11:25'!
renderMetaOn: canvas
	canvas span
		class: 'metaspan';
		with: [
			canvas text: 'chat | meta | about | faq'.]! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 21:54'!
renderSearchOn: canvas
	canvas span 
		class: 'searchspan';
		with: [
			canvas textInput 
				on: #search of: self.
			]! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 11:44'!
renderTopOn: canvas
	canvas div
		class: 'topbar';
		with: [
			canvas span 
				class: 'hlinks';
				with: [
					self renderUserOrLoginOn: canvas.
					self renderMetaOn: canvas.
					self renderSearchOn: canvas] ]! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 11:42'!
renderUserOrLoginOn: canvas
	canvas span
		class: 'userspan';
		with: [
			canvas text: 'Stephan Eggermont'.
			canvas text: ' 5073'.]! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 11:26'!
search
	^'search'! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 11:26'!
search: aString! !

!FOAgileOverflow methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 17:21'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: FOFileLibrary / #mainCss
! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
addPage: page
	self pages 
		detect: [ :each | each = page ]
		ifNone: [ self pages add: page ].
	currentPage ifNil: [ currentPage := page ].
	^page! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
addPage: page announcement: announcement
	self addPage: page.
	self announcer
		subscribe: announcement
		do: [ :ann | 
			self currentPage: page.
		]
		for: self
! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
addPage: page announcement: announcement subject: subject accessors: accessors

	self addPage: page.
	self announcer
		subscribe: announcement
		do: [ :ann |
			| temp |
			temp := subject.
			accessors do: [ :each| temp := temp perform: each ].
			page subject: temp.
			self currentPage: page.
		]
		for: self
! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
addPage: page announcement: announcement symbol: aSymbol

	self addPage: page.
	self announcer
		subscribe: announcement
		do: [ :ann |
			(ann perform: aSymbol) ifNotNil: [ page subject: (ann perform: aSymbol) ].
			self currentPage: page.
		]
		for: self
! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
children
	^self pages
! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
currentPage
	^currentPage ifNil: [ currentPage := self homepage ]! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
currentPage: aPage
	currentPage := aPage! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
goHome
	self currentPage: homepage! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
goHomeOn: announcement 
	self announcer 
		subscribe: announcement
		do: [ :ann | self currentPage: homepage ]
		for: self! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
homepage
	homepage ifNil: 
		[ self pages ifEmpty: [ ^ nil ].
		^ self pages first ].
	^ homepage! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
homepage: aPage 
	self addPage: aPage.
	homepage := aPage! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
pages
	^pages ifNil: [ pages := OrderedCollection new ]
! !

!FOPageChoice methodsFor: 'rendering' stamp: 'StephanEggermont 4/29/2011 00:25'!
renderContentOn: canvas
	currentPage 
				ifNil: 
					[ canvas text: 'Internal error in FOPageChoice: no current page set.' ]
				ifNotNil: [ canvas render: currentPage ]! !

!FOPageChoice methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:19'!
states
	^self pages
! !

WAComponent subclass: #FOViewQuestion
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Application'!

!FOViewQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:53'!
downvote 
	question downvote ! !

!FOViewQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 23:35'!
renderContentOn: canvas
	(canvas div)
		class: 'view-question';
		with: [ 
			canvas heading: question title.
			self renderVotesOn: canvas.
			canvas
				text: question contents;
				break;
				text: question tags;
				break;
				text: question author ]! !

!FOViewQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/29/2011 23:25'!
renderVotesOn: canvas
	canvas div
		class: 'votes';
		with: [
	canvas anchor 
		callback: [self upvote];
		with: [canvas html: '&#x25b2;'].
	canvas break.
	canvas
		text: question votesTotal;
		break.
	canvas anchor 
		callback: [self downvote];
		with: [canvas html: '&#x25bc;']]
	! !

!FOViewQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:36'!
subject: aQuestion
	question  := aQuestion! !

!FOViewQuestion methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:51'!
upvote
	question upvote! !

WASession subclass: #FOSession
	instanceVariableNames: 'user announcer local'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Base'!

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
announce: anAnnouncement
	self announcer announce: anAnnouncement
! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
announcer
	^announcer ifNil: [ announcer := Announcer new ]
! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
announcer: anAnnouncer
	announcer := anAnnouncer
! !

!FOSession methodsFor: 'security' stamp: 'StephanEggermont 4/29/2011 00:23'!
isLoggedIn
	user ifNotNil: [ ^ true ].
	^ false! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:24'!
loginAnnouncement
	^FOLoggedIn! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:25'!
logoutAnnouncement
	^FOLoggedOut! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
resetAnnouncer
	announcer := nil
! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
user
	^ user! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
user: anObject
	(user ~= anObject) ifTrue: [
		user := anObject.
		user ifNil: [
			self announcer announce: self logoutAnnouncement ]
		ifNotNil: [
			self announcer announce: self loginAnnouncement ]
	]! !

!FOSession methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 00:23'!
username

	user ifNil: [
		^'No user logged in.'
	].
	^ user username! !

Announcement subclass: #FOGoAskQuestion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoAskQuestion2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOGoViewQuestion
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

!FOGoViewQuestion class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:40'!
on: aQuestion
	^self new
		question: aQuestion;
		yourself! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question
	^ question! !

!FOGoViewQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:35'!
question: anObject
	question := anObject! !

Announcement subclass: #FOLoggedIn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Announcement subclass: #FOLoggedOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Announcements'!

Object subclass: #FOAnswer
	instanceVariableNames: 'author contents votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

Object subclass: #FOAuthor
	instanceVariableNames: 'userName votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:14'!
printString
	^userName ifNil: [^ 'unidentified flying user'].! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 19:13'!
userName
	^ userName! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 19:13'!
userName: anObject
	userName := anObject! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 21:26'!
votes
	^ votes! !

!FOAuthor methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 21:26'!
votes: anObject
	votes := anObject! !

Object subclass: #FOComment
	instanceVariableNames: 'author contents votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

Object subclass: #FOModel
	instanceVariableNames: 'authors questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

FOModel class
	instanceVariableNames: 'default'!

FOModel class
	instanceVariableNames: 'default'!

!FOModel class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 19:09'!
default 
	^default ifNil: [default := self new]! !

!FOModel methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:41'!
authorNamed: aName
	|retVal|
	retVal := authors detect: [:each | each userName = aName] ifNone: [ 	
		|author|
		author := FOAuthor new.
		author userName: aName.
		self authors add: author.
		retVal :=author].
	^retVal.! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 19:10'!
authors
	^ authors! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 19:10'!
authors: anObject
	authors := anObject! !

!FOModel methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 10/18/2010 13:41'!
fake
	|author question|
	author := self authorNamed: 'Stephan Eggermont'.
	question := FOQuestion new.
	question title: 'started from command line';
		author: author.
	self questions add: question.
	 ! !

!FOModel methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 19:09'!
initialize
	questions := OrderedCollection new.
	authors := OrderedCollection new.! !

!FOModel methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:47'!
questionBy: anAuthor
	|question|
	question := FOQuestion new.
	question author: anAuthor.
	questions add: question.
	^question! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 19:10'!
questions
	^ questions! !

!FOModel methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 19:10'!
questions: anObject
	questions := anObject! !

!FOModel methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 8/24/2010 20:50'!
questionsOf: anAuthor
	^questions select: [:each | each author = anAuthor]! !

Object subclass: #FOQuestion
	instanceVariableNames: 'title contents author answers comments votes tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOQuestion class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:24'!
contentsField
	^DEMemoField new
		label: 'Contents';
		accessor: #( contents );
		yourself! !

!FOQuestion class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:13'!
editFields
	^self fields! !

!FOQuestion class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:24'!
fields
	^#(titleField contentsField tagsField)! !

!FOQuestion class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:24'!
tagsField
	^DEStringField new
		label: 'Tags';
		accessor: #( tags );
		yourself! !

!FOQuestion class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 16:24'!
titleField
	^DEStringField new
		label: 'Title';
		accessor: #( title );
		yourself! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 14:53'!
answers
	^ answers ifNil: [answers := OrderedCollection new]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
answers: anObject
	answers := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
author
	^ author! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
author: anObject
	author := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
comments
	^ comments! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
comments: anObject
	comments := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
contents
	^ contents! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
contents: anObject
	contents := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 23:02'!
downvote
	self votes add: FOVote down! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:04'!
tags
	^ tags! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:04'!
tags: anObject
	tags := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
title
	^ title! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
title: anObject
	title := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 23:02'!
upvote
	self votes add: FOVote up! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:13'!
votes
	^ votes ifNil: [votes := OrderedCollection new.]! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 20:48'!
votes: anObject
	votes := anObject! !

!FOQuestion methodsFor: 'accessing' stamp: 'StephanEggermont 4/29/2011 16:41'!
votesTotal
	^ self votes
		inject: 0
		into: [ :sum :each | 
			each up
				ifTrue: [ sum + 1 ]
				ifFalse: [ sum - 1 ] ]! !

Object subclass: #FOVote
	instanceVariableNames: 'author subject up'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Forum-Model'!

!FOVote class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:56'!
down
	^self new up: false ; yourself.! !

!FOVote class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 4/28/2011 22:56'!
up
	^self new up: true ; yourself.! !

!FOVote methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 21:26'!
author
	^ author! !

!FOVote methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 21:26'!
author: anObject
	author := anObject! !

!FOVote methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 21:26'!
subject
	^ subject! !

!FOVote methodsFor: 'accessing' stamp: 'StephanEggermont 8/24/2010 21:26'!
subject: anObject
	subject := anObject! !

!FOVote methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 23:01'!
up
	^ up ifNil: [^true]! !

!FOVote methodsFor: 'accessing' stamp: 'StephanEggermont 4/28/2011 22:57'!
up: anObject
	up := anObject! !
FOAgileOverflow initialize!
